diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/mgt-headers.cc ns-3.39/src/wifi/model/mgt-headers.cc
--- ns-3.38/src/wifi/model/mgt-headers.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/mgt-headers.cc	2023-07-05 14:23:48.113428400 -0700
@@ -22,6 +22,7 @@
 #include "mgt-headers.h"
 
 #include "ns3/address-utils.h"
+#include "ns3/packet.h"
 #include "ns3/simulator.h"
 
 namespace ns3
@@ -33,169 +34,6 @@
 
 NS_OBJECT_ENSURE_REGISTERED(MgtProbeRequestHeader);
 
-MgtProbeRequestHeader::~MgtProbeRequestHeader()
-{
-}
-
-void
-MgtProbeRequestHeader::SetSsid(const Ssid& ssid)
-{
-    m_ssid = ssid;
-}
-
-void
-MgtProbeRequestHeader::SetSsid(Ssid&& ssid)
-{
-    m_ssid = std::move(ssid);
-}
-
-const Ssid&
-MgtProbeRequestHeader::GetSsid() const
-{
-    return m_ssid;
-}
-
-void
-MgtProbeRequestHeader::SetSupportedRates(const SupportedRates& rates)
-{
-    m_rates = rates;
-}
-
-void
-MgtProbeRequestHeader::SetSupportedRates(SupportedRates&& rates)
-{
-    m_rates = std::move(rates);
-}
-
-void
-MgtProbeRequestHeader::SetExtendedCapabilities(const ExtendedCapabilities& extendedCapabilities)
-{
-    m_extendedCapability = extendedCapabilities;
-}
-
-void
-MgtProbeRequestHeader::SetExtendedCapabilities(ExtendedCapabilities&& extendedCapabilities)
-{
-    m_extendedCapability = std::move(extendedCapabilities);
-}
-
-const std::optional<ExtendedCapabilities>&
-MgtProbeRequestHeader::GetExtendedCapabilities() const
-{
-    return m_extendedCapability;
-}
-
-void
-MgtProbeRequestHeader::SetHtCapabilities(const HtCapabilities& htCapabilities)
-{
-    m_htCapability = htCapabilities;
-}
-
-void
-MgtProbeRequestHeader::SetHtCapabilities(HtCapabilities&& htCapabilities)
-{
-    m_htCapability = std::move(htCapabilities);
-}
-
-const std::optional<HtCapabilities>&
-MgtProbeRequestHeader::GetHtCapabilities() const
-{
-    return m_htCapability;
-}
-
-void
-MgtProbeRequestHeader::SetVhtCapabilities(const VhtCapabilities& vhtCapabilities)
-{
-    m_vhtCapability = vhtCapabilities;
-}
-
-void
-MgtProbeRequestHeader::SetVhtCapabilities(VhtCapabilities&& vhtCapabilities)
-{
-    m_vhtCapability = std::move(vhtCapabilities);
-}
-
-const std::optional<VhtCapabilities>&
-MgtProbeRequestHeader::GetVhtCapabilities() const
-{
-    return m_vhtCapability;
-}
-
-void
-MgtProbeRequestHeader::SetHeCapabilities(const HeCapabilities& heCapabilities)
-{
-    m_heCapability = heCapabilities;
-}
-
-void
-MgtProbeRequestHeader::SetHeCapabilities(HeCapabilities&& heCapabilities)
-{
-    m_heCapability = std::move(heCapabilities);
-}
-
-const std::optional<HeCapabilities>&
-MgtProbeRequestHeader::GetHeCapabilities() const
-{
-    return m_heCapability;
-}
-
-void
-MgtProbeRequestHeader::SetEhtCapabilities(const EhtCapabilities& ehtCapabilities)
-{
-    m_ehtCapability = ehtCapabilities;
-}
-
-void
-MgtProbeRequestHeader::SetEhtCapabilities(EhtCapabilities&& ehtCapabilities)
-{
-    m_ehtCapability = std::move(ehtCapabilities);
-}
-
-const std::optional<EhtCapabilities>&
-MgtProbeRequestHeader::GetEhtCapabilities() const
-{
-    return m_ehtCapability;
-}
-
-const SupportedRates&
-MgtProbeRequestHeader::GetSupportedRates() const
-{
-    return m_rates;
-}
-
-uint32_t
-MgtProbeRequestHeader::GetSerializedSize() const
-{
-    uint32_t size = 0;
-    size += m_ssid.GetSerializedSize();
-    size += m_rates.GetSerializedSize();
-    if (m_rates.GetNRates() > 8)
-    {
-        size += m_rates.extended->GetSerializedSize();
-    }
-    if (m_extendedCapability.has_value())
-    {
-        size += m_extendedCapability->GetSerializedSize();
-    }
-    if (m_htCapability.has_value())
-    {
-        size += m_htCapability->GetSerializedSize();
-    }
-    if (m_vhtCapability.has_value())
-    {
-        size += m_vhtCapability->GetSerializedSize();
-    }
-    if (m_heCapability.has_value())
-    {
-        size += m_heCapability->GetSerializedSize();
-    }
-    if (m_ehtCapability.has_value())
-    {
-        size += m_ehtCapability->GetSerializedSize();
-    }
-    return size;
-}
-
 TypeId
 MgtProbeRequestHeader::GetTypeId()
 {
@@ -212,107 +50,26 @@
     return GetTypeId();
 }
 
-void
-MgtProbeRequestHeader::Print(std::ostream& os) const
-{
-    os << "ssid=" << m_ssid << ", "
-       << "rates=" << m_rates << ", ";
-    if (m_extendedCapability.has_value())
-    {
-        os << "Extended Capabilities=" << *m_extendedCapability << " , ";
-    }
-    if (m_htCapability.has_value())
-    {
-        os << "HT Capabilities=" << *m_htCapability << " , ";
-    }
-    if (m_vhtCapability.has_value())
-    {
-        os << "VHT Capabilities=" << *m_vhtCapability << " , ";
-    }
-    if (m_heCapability.has_value())
-    {
-        os << "HE Capabilities=" << *m_heCapability << " , ";
-    }
-    if (m_ehtCapability.has_value())
-    {
-        os << "EHT Capabilities=" << *m_ehtCapability;
-    }
-}
-
-void
-MgtProbeRequestHeader::Serialize(Buffer::Iterator start) const
-{
-    Buffer::Iterator i = start;
-    i = m_ssid.Serialize(i);
-    i = m_rates.Serialize(i);
-    if (m_rates.GetNRates() > 8)
-    {
-        i = m_rates.extended->Serialize(i);
-    }
-    if (m_extendedCapability.has_value())
-    {
-        i = m_extendedCapability->Serialize(i);
-    }
-    if (m_htCapability.has_value())
-    {
-        i = m_htCapability->Serialize(i);
-    }
-    if (m_vhtCapability.has_value())
-    {
-        i = m_vhtCapability->Serialize(i);
-    }
-    if (m_heCapability.has_value())
-    {
-        i = m_heCapability->Serialize(i);
-    }
-    if (m_ehtCapability.has_value())
-    {
-        i = m_ehtCapability->Serialize(i);
-    }
-}
-
-uint32_t
-MgtProbeRequestHeader::Deserialize(Buffer::Iterator start)
-{
-    Buffer::Iterator i = start;
-    i = m_ssid.Deserialize(i);
-    i = m_rates.Deserialize(i);
-    i = WifiInformationElement::DeserializeIfPresent(m_rates.extended, i, &m_rates);
-    i = WifiInformationElement::DeserializeIfPresent(m_extendedCapability, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_htCapability, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_vhtCapability, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_heCapability, i);
-    const bool is2_4Ghz = m_rates.IsSupportedRate(
-        1000000 /* 1 Mbit/s */); // TODO: use presence of VHT capabilities IE and HE 6 GHz Band
-                                 // Capabilities IE once the later is implemented
-    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i, is2_4Ghz, m_heCapability);
-    return i.GetDistanceFrom(start);
-}
-
 /***********************************************************
  *          Probe Response
  ***********************************************************/
 
 NS_OBJECT_ENSURE_REGISTERED(MgtProbeResponseHeader);
 
-MgtProbeResponseHeader::MgtProbeResponseHeader()
-{
-}
-
-MgtProbeResponseHeader::~MgtProbeResponseHeader()
-{
-}
-
-uint64_t
-MgtProbeResponseHeader::GetTimestamp() const
+TypeId
+MgtProbeResponseHeader::GetTypeId()
 {
-    return m_timestamp;
+    static TypeId tid = TypeId("ns3::MgtProbeResponseHeader")
+                            .SetParent<Header>()
+                            .SetGroupName("Wifi")
+                            .AddConstructor<MgtProbeResponseHeader>();
+    return tid;
 }
 
-const Ssid&
-MgtProbeResponseHeader::GetSsid() const
+TypeId
+MgtProbeResponseHeader::GetInstanceTypeId() const
 {
-    return m_ssid;
+    return GetTypeId();
 }
 
 uint64_t
@@ -321,576 +78,59 @@
     return m_beaconInterval;
 }
 
-const SupportedRates&
-MgtProbeResponseHeader::GetSupportedRates() const
-{
-    return m_rates;
-}
-
-void
-MgtProbeResponseHeader::SetCapabilities(const CapabilityInformation& capabilities)
-{
-    m_capability = capabilities;
-}
-
-void
-MgtProbeResponseHeader::SetCapabilities(CapabilityInformation&& capabilities)
-{
-    m_capability = std::move(capabilities);
-}
-
-const CapabilityInformation&
-MgtProbeResponseHeader::GetCapabilities() const
-{
-    return m_capability;
-}
-
-void
-MgtProbeResponseHeader::SetExtendedCapabilities(const ExtendedCapabilities& extendedCapabilities)
-{
-    m_extendedCapability = extendedCapabilities;
-}
-
-void
-MgtProbeResponseHeader::SetExtendedCapabilities(ExtendedCapabilities&& extendedCapabilities)
-{
-    m_extendedCapability = std::move(extendedCapabilities);
-}
-
-const std::optional<ExtendedCapabilities>&
-MgtProbeResponseHeader::GetExtendedCapabilities() const
-{
-    return m_extendedCapability;
-}
-
-void
-MgtProbeResponseHeader::SetHtCapabilities(const HtCapabilities& htCapabilities)
-{
-    m_htCapability = htCapabilities;
-}
-
-void
-MgtProbeResponseHeader::SetHtCapabilities(HtCapabilities&& htCapabilities)
-{
-    m_htCapability = std::move(htCapabilities);
-}
-
-const std::optional<HtCapabilities>&
-MgtProbeResponseHeader::GetHtCapabilities() const
-{
-    return m_htCapability;
-}
-
-void
-MgtProbeResponseHeader::SetHtOperation(const HtOperation& htOperation)
-{
-    m_htOperation = htOperation;
-}
-
-void
-MgtProbeResponseHeader::SetHtOperation(HtOperation&& htOperation)
-{
-    m_htOperation = std::move(htOperation);
-}
-
-const std::optional<HtOperation>&
-MgtProbeResponseHeader::GetHtOperation() const
-{
-    return m_htOperation;
-}
-
-void
-MgtProbeResponseHeader::SetVhtCapabilities(const VhtCapabilities& vhtCapabilities)
-{
-    m_vhtCapability = vhtCapabilities;
-}
-
-void
-MgtProbeResponseHeader::SetVhtCapabilities(VhtCapabilities&& vhtCapabilities)
-{
-    m_vhtCapability = std::move(vhtCapabilities);
-}
-
-const std::optional<VhtCapabilities>&
-MgtProbeResponseHeader::GetVhtCapabilities() const
-{
-    return m_vhtCapability;
-}
-
-void
-MgtProbeResponseHeader::SetVhtOperation(const VhtOperation& vhtOperation)
-{
-    m_vhtOperation = vhtOperation;
-}
-
-void
-MgtProbeResponseHeader::SetVhtOperation(VhtOperation&& vhtOperation)
-{
-    m_vhtOperation = std::move(vhtOperation);
-}
-
-const std::optional<VhtOperation>&
-MgtProbeResponseHeader::GetVhtOperation() const
-{
-    return m_vhtOperation;
-}
-
-void
-MgtProbeResponseHeader::SetHeCapabilities(const HeCapabilities& heCapabilities)
-{
-    m_heCapability = heCapabilities;
-}
-
-void
-MgtProbeResponseHeader::SetHeCapabilities(HeCapabilities&& heCapabilities)
-{
-    m_heCapability = std::move(heCapabilities);
-}
-
-const std::optional<HeCapabilities>&
-MgtProbeResponseHeader::GetHeCapabilities() const
-{
-    return m_heCapability;
-}
-
-void
-MgtProbeResponseHeader::SetHeOperation(const HeOperation& heOperation)
-{
-    m_heOperation = heOperation;
-}
-
-void
-MgtProbeResponseHeader::SetHeOperation(HeOperation&& heOperation)
-{
-    m_heOperation = std::move(heOperation);
-}
-
-const std::optional<HeOperation>&
-MgtProbeResponseHeader::GetHeOperation() const
-{
-    return m_heOperation;
-}
-
-void
-MgtProbeResponseHeader::SetEhtCapabilities(const EhtCapabilities& ehtCapabilities)
-{
-    m_ehtCapability = ehtCapabilities;
-}
-
-void
-MgtProbeResponseHeader::SetEhtCapabilities(EhtCapabilities&& ehtCapabilities)
-{
-    m_ehtCapability = std::move(ehtCapabilities);
-}
-
-const std::optional<EhtCapabilities>&
-MgtProbeResponseHeader::GetEhtCapabilities() const
-{
-    return m_ehtCapability;
-}
-
-void
-MgtProbeResponseHeader::SetEhtOperation(const EhtOperation& ehtOperation)
-{
-    m_ehtOperation = ehtOperation;
-}
-
-void
-MgtProbeResponseHeader::SetEhtOperation(EhtOperation&& ehtOperation)
-{
-    m_ehtOperation = std::move(ehtOperation);
-}
-
-const std::optional<EhtOperation>&
-MgtProbeResponseHeader::GetEhtOperation() const
-{
-    return m_ehtOperation;
-}
-
-void
-MgtProbeResponseHeader::SetSsid(const Ssid& ssid)
-{
-    m_ssid = ssid;
-}
-
-void
-MgtProbeResponseHeader::SetSsid(Ssid&& ssid)
-{
-    m_ssid = std::move(ssid);
-}
-
 void
 MgtProbeResponseHeader::SetBeaconIntervalUs(uint64_t us)
 {
     m_beaconInterval = us;
 }
 
-void
-MgtProbeResponseHeader::SetSupportedRates(const SupportedRates& rates)
-{
-    m_rates = rates;
-}
-
-void
-MgtProbeResponseHeader::SetSupportedRates(SupportedRates&& rates)
-{
-    m_rates = std::move(rates);
-}
-
-void
-MgtProbeResponseHeader::SetDsssParameterSet(const DsssParameterSet& dsssParameterSet)
-{
-    m_dsssParameterSet = dsssParameterSet;
-}
-
-void
-MgtProbeResponseHeader::SetDsssParameterSet(DsssParameterSet&& dsssParameterSet)
-{
-    m_dsssParameterSet = std::move(dsssParameterSet);
-}
-
-const std::optional<DsssParameterSet>&
-MgtProbeResponseHeader::GetDsssParameterSet() const
-{
-    return m_dsssParameterSet;
-}
-
-void
-MgtProbeResponseHeader::SetErpInformation(const ErpInformation& erpInformation)
-{
-    m_erpInformation = erpInformation;
-}
-
-void
-MgtProbeResponseHeader::SetErpInformation(ErpInformation&& erpInformation)
-{
-    m_erpInformation = std::move(erpInformation);
-}
-
-const std::optional<ErpInformation>&
-MgtProbeResponseHeader::GetErpInformation() const
-{
-    return m_erpInformation;
-}
-
-void
-MgtProbeResponseHeader::SetEdcaParameterSet(const EdcaParameterSet& edcaParameters)
-{
-    m_edcaParameterSet = edcaParameters;
-}
-
-void
-MgtProbeResponseHeader::SetEdcaParameterSet(EdcaParameterSet&& edcaParameters)
-{
-    m_edcaParameterSet = std::move(edcaParameters);
-}
-
-void
-MgtProbeResponseHeader::SetMuEdcaParameterSet(const MuEdcaParameterSet& muEdcaParameters)
-{
-    m_muEdcaParameterSet = muEdcaParameters;
-}
-
-void
-MgtProbeResponseHeader::SetMuEdcaParameterSet(MuEdcaParameterSet&& muEdcaParameters)
-{
-    m_muEdcaParameterSet = std::move(muEdcaParameters);
-}
-
-void
-MgtProbeResponseHeader::SetReducedNeighborReport(const ReducedNeighborReport& reducedNeighborReport)
-{
-    m_reducedNeighborReport = reducedNeighborReport;
-}
-
-void
-MgtProbeResponseHeader::SetReducedNeighborReport(ReducedNeighborReport&& reducedNeighborReport)
-{
-    m_reducedNeighborReport = std::move(reducedNeighborReport);
-}
-
-void
-MgtProbeResponseHeader::SetMultiLinkElement(const MultiLinkElement& multiLinkElement)
-{
-    m_multiLinkElement = multiLinkElement;
-}
-
-void
-MgtProbeResponseHeader::SetMultiLinkElement(MultiLinkElement&& multiLinkElement)
-{
-    m_multiLinkElement = std::move(multiLinkElement);
-}
-
-const std::optional<EdcaParameterSet>&
-MgtProbeResponseHeader::GetEdcaParameterSet() const
-{
-    return m_edcaParameterSet;
-}
-
-const std::optional<MuEdcaParameterSet>&
-MgtProbeResponseHeader::GetMuEdcaParameterSet() const
-{
-    return m_muEdcaParameterSet;
-}
-
-const std::optional<ReducedNeighborReport>&
-MgtProbeResponseHeader::GetReducedNeighborReport() const
-{
-    return m_reducedNeighborReport;
-}
-
-const std::optional<MultiLinkElement>&
-MgtProbeResponseHeader::GetMultiLinkElement() const
+const CapabilityInformation&
+MgtProbeResponseHeader::Capabilities() const
 {
-    return m_multiLinkElement;
+    return m_capability;
 }
 
-TypeId
-MgtProbeResponseHeader::GetTypeId()
+CapabilityInformation&
+MgtProbeResponseHeader::Capabilities()
 {
-    static TypeId tid = TypeId("ns3::MgtProbeResponseHeader")
-                            .SetParent<Header>()
-                            .SetGroupName("Wifi")
-                            .AddConstructor<MgtProbeResponseHeader>();
-    return tid;
+    return m_capability;
 }
 
-TypeId
-MgtProbeResponseHeader::GetInstanceTypeId() const
+uint64_t
+MgtProbeResponseHeader::GetTimestamp() const
 {
-    return GetTypeId();
+    return m_timestamp;
 }
 
 uint32_t
-MgtProbeResponseHeader::GetSerializedSize() const
+MgtProbeResponseHeader::GetSerializedSizeImpl() const
 {
-    uint32_t size = 0;
-    size += 8; // timestamp
-    size += 2; // beacon interval
+    uint32_t size = 8 /* timestamp */ + 2 /* beacon interval */;
     size += m_capability.GetSerializedSize();
-    size += m_ssid.GetSerializedSize();
-    size += m_rates.GetSerializedSize();
-    if (m_dsssParameterSet.has_value())
-    {
-        size += m_dsssParameterSet->GetSerializedSize();
-    }
-    if (m_erpInformation.has_value())
-    {
-        size += m_erpInformation->GetSerializedSize();
-    }
-    if (m_rates.GetNRates() > 8)
-    {
-        size += m_rates.extended->GetSerializedSize();
-    }
-    if (m_edcaParameterSet.has_value())
-    {
-        size += m_edcaParameterSet->GetSerializedSize();
-    }
-    if (m_extendedCapability.has_value())
-    {
-        size += m_extendedCapability->GetSerializedSize();
-    }
-    if (m_htCapability.has_value())
-    {
-        size += m_htCapability->GetSerializedSize();
-    }
-    if (m_htOperation.has_value())
-    {
-        size += m_htOperation->GetSerializedSize();
-    }
-    if (m_vhtCapability.has_value())
-    {
-        size += m_vhtCapability->GetSerializedSize();
-    }
-    if (m_vhtOperation.has_value())
-    {
-        size += m_vhtOperation->GetSerializedSize();
-    }
-    if (m_reducedNeighborReport.has_value())
-    {
-        size += m_reducedNeighborReport->GetSerializedSize();
-    }
-    if (m_heCapability.has_value())
-    {
-        size += m_heCapability->GetSerializedSize();
-    }
-    if (m_heOperation.has_value())
-    {
-        size += m_heOperation->GetSerializedSize();
-    }
-    if (m_muEdcaParameterSet.has_value())
-    {
-        size += m_muEdcaParameterSet->GetSerializedSize();
-    }
-    if (m_multiLinkElement.has_value())
-    {
-        size += m_multiLinkElement->GetSerializedSize();
-    }
-    if (m_ehtCapability.has_value())
-    {
-        size += m_ehtCapability->GetSerializedSize();
-    }
-    if (m_ehtOperation.has_value())
-    {
-        size += m_ehtOperation->GetSerializedSize();
-    }
+    size += WifiMgtHeader<MgtProbeResponseHeader, ProbeResponseElems>::GetSerializedSizeImpl();
     return size;
 }
 
 void
-MgtProbeResponseHeader::Print(std::ostream& os) const
-{
-    os << "ssid=" << m_ssid << ", "
-       << "rates=" << m_rates << ", ";
-    if (m_erpInformation.has_value())
-    {
-        os << "ERP information=" << *m_erpInformation << ", ";
-    }
-    if (m_extendedCapability.has_value())
-    {
-        os << "Extended Capabilities=" << *m_extendedCapability << " , ";
-    }
-    if (m_htCapability.has_value())
-    {
-        os << "HT Capabilities=" << *m_htCapability << " , ";
-    }
-    if (m_htOperation.has_value())
-    {
-        os << "HT Operation=" << *m_htOperation << " , ";
-    }
-    if (m_vhtCapability.has_value())
-    {
-        os << "VHT Capabilities=" << *m_vhtCapability << " , ";
-    }
-    if (m_vhtOperation.has_value())
-    {
-        os << "VHT Operation=" << *m_vhtOperation << " , ";
-    }
-    if (m_heCapability.has_value())
-    {
-        os << "HE Capabilities=" << *m_heCapability << " , ";
-    }
-    if (m_heOperation.has_value())
-    {
-        os << "HE Operation=" << *m_heOperation << " , ";
-    }
-    if (m_ehtCapability.has_value())
-    {
-        os << "EHT Capabilities=" << *m_ehtCapability;
-    }
-    if (m_ehtOperation.has_value())
-    {
-        os << "EHT Operation=" << *m_ehtOperation;
-    }
-}
-
-void
-MgtProbeResponseHeader::Serialize(Buffer::Iterator start) const
+MgtProbeResponseHeader::SerializeImpl(Buffer::Iterator start) const
 {
     Buffer::Iterator i = start;
     i.WriteHtolsbU64(Simulator::Now().GetMicroSeconds());
     i.WriteHtolsbU16(static_cast<uint16_t>(m_beaconInterval / 1024));
     i = m_capability.Serialize(i);
-    i = m_ssid.Serialize(i);
-    i = m_rates.Serialize(i);
-    if (m_dsssParameterSet.has_value())
-    {
-        i = m_dsssParameterSet->Serialize(i);
-    }
-    if (m_erpInformation.has_value())
-    {
-        i = m_erpInformation->Serialize(i);
-    }
-    if (m_rates.GetNRates() > 8)
-    {
-        i = m_rates.extended->Serialize(i);
-    }
-    if (m_edcaParameterSet.has_value())
-    {
-        i = m_edcaParameterSet->Serialize(i);
-    }
-    if (m_extendedCapability.has_value())
-    {
-        i = m_extendedCapability->Serialize(i);
-    }
-    if (m_htCapability.has_value())
-    {
-        i = m_htCapability->Serialize(i);
-    }
-    if (m_htOperation.has_value())
-    {
-        i = m_htOperation->Serialize(i);
-    }
-    if (m_vhtCapability.has_value())
-    {
-        i = m_vhtCapability->Serialize(i);
-    }
-    if (m_vhtOperation.has_value())
-    {
-        i = m_vhtOperation->Serialize(i);
-    }
-    if (m_reducedNeighborReport.has_value())
-    {
-        i = m_reducedNeighborReport->Serialize(i);
-    }
-    if (m_heCapability.has_value())
-    {
-        i = m_heCapability->Serialize(i);
-    }
-    if (m_heOperation.has_value())
-    {
-        i = m_heOperation->Serialize(i);
-    }
-    if (m_muEdcaParameterSet.has_value())
-    {
-        i = m_muEdcaParameterSet->Serialize(i);
-    }
-    if (m_multiLinkElement.has_value())
-    {
-        i = m_multiLinkElement->Serialize(i);
-    }
-    if (m_ehtCapability.has_value())
-    {
-        i = m_ehtCapability->Serialize(i);
-    }
-    if (m_ehtOperation.has_value())
-    {
-        i = m_ehtOperation->Serialize(i);
-    }
+    WifiMgtHeader<MgtProbeResponseHeader, ProbeResponseElems>::SerializeImpl(i);
 }
 
 uint32_t
-MgtProbeResponseHeader::Deserialize(Buffer::Iterator start)
+MgtProbeResponseHeader::DeserializeImpl(Buffer::Iterator start)
 {
-    Buffer::Iterator tmp;
     Buffer::Iterator i = start;
     m_timestamp = i.ReadLsbtohU64();
     m_beaconInterval = i.ReadLsbtohU16();
     m_beaconInterval *= 1024;
     i = m_capability.Deserialize(i);
-    i = m_ssid.Deserialize(i);
-    i = m_rates.Deserialize(i);
-    i = WifiInformationElement::DeserializeIfPresent(m_dsssParameterSet, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_erpInformation, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_rates.extended, i, &m_rates);
-    i = WifiInformationElement::DeserializeIfPresent(m_edcaParameterSet, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_extendedCapability, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_htCapability, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_htOperation, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_vhtCapability, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_vhtOperation, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_reducedNeighborReport, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_heCapability, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_heOperation, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_muEdcaParameterSet, i);
-    i = WifiInformationElement::DeserializeIfPresent(m_multiLinkElement, i, WIFI_MAC_MGT_BEACON);
-    const bool is2_4Ghz = m_rates.IsSupportedRate(
-        1000000 /* 1 Mbit/s */); // TODO: use presence of VHT capabilities IE and HE 6 GHz Band
-                                 // Capabilities IE once the later is implemented
-    i = WifiInformationElement::DeserializeIfPresent(m_ehtCapability, i, is2_4Ghz, m_heCapability);
-    i = WifiInformationElement::DeserializeIfPresent(m_ehtOperation, i);
-
-    return i.GetDistanceFrom(start);
+    auto distance = i.GetDistanceFrom(start);
+    return distance + WifiMgtHeader<MgtProbeResponseHeader, ProbeResponseElems>::DeserializeImpl(i);
 }
 
 /***********************************************************
@@ -916,37 +156,26 @@
 
 NS_OBJECT_ENSURE_REGISTERED(MgtAssocRequestHeader);
 
-MgtAssocRequestHeader::MgtAssocRequestHeader()
-    : m_listenInterval(0)
-{
-}
-
-MgtAssocRequestHeader::~MgtAssocRequestHeader()
-{
-}
-
-void
-MgtAssocRequestHeader::SetSsid(const Ssid& ssid)
-{
-    m_ssid = ssid;
-}
-
-void
-MgtAssocRequestHeader::SetSsid(Ssid&& ssid)
+TypeId
+MgtAssocRequestHeader::GetTypeId()
 {
-    m_ssid = std::move(ssid);
+    static TypeId tid = TypeId("ns3::MgtAssocRequestHeader")
+                            .SetParent<Header>()
+                            .SetGroupName("Wifi")
+                            .AddConstructor<MgtAssocRequestHeader>();
+    return tid;
 }
 
-void
-MgtAssocRequestHeader::SetSupportedRates(const SupportedRates& rates)
+TypeId
+MgtAssocRequestHeader::GetInstanceTypeId() const
 {
-    m_rates = rates;
+    return GetTypeId();
 }
 
-void
-MgtAssocRequestHeader::SetSupportedRates(SupportedRates&& rates)
+uint16_t
+MgtAssocRequestHeader::GetListenInterval() const
 {
-    m_rates = std::move(rates);
+    return m_listenInterval;
 }
 
 void
